
Database - Feature #2231

LockType error processing

01/22/2014 03:01 PM - Ovidiu Maxiniuc

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Vadim Nebogatov % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stablization for Server

Features

  

billable: No version:  

vendor_id: GCD   

Description

History

#1 - 01/22/2014 03:12 PM - Ovidiu Maxiniuc

With the emergence of the new dynamic features in P2J some of the parameters of the methods/attributes cannot be checked at conversion time.

This is the case of LockType.fromLockNowait() that will be called from multiple places, each of those expecting different error messages in Progress.

There are two directions:

let the fromLockNowait aware of the calling location by adding an additional parameter (string or int)

fromLockNowait throws an exception and handling the error case will be done by the caller.

#2 - 02/20/2014 12:32 PM - Greg Shah

- Project changed from Base Language to Database

#3 - 02/24/2014 11:15 AM - Eric Faulhaber

- Assignee set to Vadim Nebogatov

#4 - 03/30/2014 04:06 PM - Vadim Nebogatov

I have selected the second option suggested in note 1.

FIND- and GET- methods tested with wrong lock and nowait values. LockType changes: it will throw special LockTypeException extends Exception in

such cases. This exception is processed in all LockType.fromLockNowait usages.

This exception will be internal to the persistence framework and will not be exposed to converted code.

#5 - 03/31/2014 12:06 PM - Vadim Nebogatov

- File vmn_upd20140331a.zip added

Attached update vmn_upd20140331a.zip.

Passed cases:

h:FIND-BY-ROWID(rr, 11, NO-WAIT).

FIND-BY-ROWID, FIND-FIRST etc., second argument must be NO-LOCK, SHARE-LOCK or EXCLUSIVE-LOCK. (7344) 
h:FIND-BY-ROWID(rr, 11, 12).

FIND method argument must be NO-WAIT, or 0 or ?. (7343) 

h:FIND-BY-ROWID(rr, NO-LOCK, 87).

FIND method argument must be NO-WAIT, or 0 or ?. (7343) 

h:FIND-FIRST("where", NO-LOCK, 87).

FIND method argument must be NO-WAIT, or 0 or ?. (7343) 

h:FIND-FIRST("where", 11, 87).

FIND method argument must be NO-WAIT, or 0 or ?. (7343) 

h:FIND-FIRST("where", 23, 6090).

FIND-BY-ROWID, FIND-FIRST etc., second argument must be NO-LOCK, SHARE-LOCK or EXCLUSIVE-LOCK. (7344) 

h:FIND-LAST("where", 23, 6090).

FIND-BY-ROWID, FIND-FIRST etc., second argument must be NO-LOCK, SHARE-LOCK or EXCLUSIVE-LOCK. (7344) 

h:FIND-LAST("where", 11, 87).

FIND method argument must be NO-WAIT, or 0 or ?. (7343) 

h:FIND-UNIQUE("where", 23, 6090).

FIND-BY-ROWID, FIND-FIRST etc., second argument must be NO-LOCK, SHARE-LOCK or EXCLUSIVE-LOCK. (7344) 

h:FIND-UNIQUE("where", 11, 87).

FIND method argument must be NO-WAIT, or 0 or ?. (7343) 

h:FIND-UNIQUE("where",11, NO-WAIT).

FIND-BY-ROWID, FIND-FIRST etc., second argument must be NO-LOCK, SHARE-LOCK or EXCLUSIVE-LOCK. (7344) 

QUERY hQuery:GET-FIRST(11, 6090).

The first argument to QUERY GET methods must be NO-LOCK, SHARE-LOCK or EXCLUSIVE-LOCK (7314)

QUERY hQuery:GET-FIRST(11, 90).

QUERY GET second argument must be NO-WAIT or 0. (7360)

QUERY hQuery:GET-FIRST(6209, 33).

QUERY GET second argument must be NO-WAIT or 0. (7360)

QUERY hQuery:GET-LAST(11, 90).

QUERY GET second argument must be NO-WAIT or 0. (7360)

QUERY hQuery:GET-CURRENT(11, 90).

QUERY GET second argument must be NO-WAIT or 0. (7360)

QUERY hQuery:GET-CURRENT(11, 0).

The first argument to QUERY GET methods must be NO-LOCK, SHARE-LOCK or EXCLUSIVE-LOCK (7314)

QUERY hQuery:GET-PREV(11, 0).

The first argument to QUERY GET methods must be NO-LOCK, SHARE-LOCK or EXCLUSIVE-LOCK (7314)

QUERY hQuery:GET-NEXT(11, 0).

The first argument to QUERY GET methods must be NO-LOCK, SHARE-LOCK or EXCLUSIVE-LOCK (7314)

 

Test cases look like:

1)

def temp-table tt field i as int.

create tt.

def var h as handle.

create query h.

h:add-buffer(buffer tt:handle).

h:query-prepare("for each tt") no-error.

h:QUERY-OPEN().

h:GET-PREV(11, 0).

 

2)

def temp-table tt field i as int.

create tt.

def var h as handle.

create buffer h for table "tt".

def var rr as rowid.

rr = ROWID(tt).

h:FIND-FIRST("where", NO-LOCK, 87).
#6 - 03/31/2014 05:21 PM - Eric Faulhaber

The update looks good. Please regression test.

#7 - 04/02/2014 03:32 AM - Vadim Nebogatov

Regression 20140401_172003 completed with 4 FAILED tests:

1. tc_job_002 FAILED failure in step 40: 'Unexpected EOF in actual at page # 1.'

2. gso_190 FAILED failure in step 27: 'timeout before the specific screen buffer became available (Mismatched data at line 21, column 0. Expected ''

(0x0000 at relative Y 21, relative X 0) and found 'R' (0x0052 at relative Y 21, relative X 0).)'

3. tc_dc_slot_027 FAILED failure in step 20: 'timeout before the specific screen buffer became available (Mismatched data at line 4, column 0.

Expected '' (0x0000 at relative Y 4, relative X 0) and found 'L' (0x004C at relative Y 4, relative X 0).)'

4. tc_dc_slot_029 FAILED failure in step 20: 'timeout before the specific screen buffer became available (Mismatched data at line 4, column 0.

Expected '' (0x0000 at relative Y 4, relative X 0) and found 'L' (0x004C at relative Y 4, relative X 0).)'

Regression started one more time.

#8 - 04/02/2014 01:41 PM - Vadim Nebogatov

Second regression 20140402_084955 is completed with 2 FAILED tests:

1. tc_job_002 FAILED failure in step 40: failure in step 40: 'Unexpected EOF in actual at page # 1.'

2. tc_job_clock_002 FAILED failure in step 20: 'timeout before the specific screen buffer became available (Mismatched data at line 5, column 18.

Expected '' (0x0000 at relative Y 5, relative X 18) and found '┌' (0x250C at relative Y 5, relative X 18).)'

So, it seems regression passed.

#9 - 04/02/2014 04:22 PM - Eric Faulhaber

Yes, please commit and distribute the update.

#10 - 04/02/2014 05:49 PM - Vadim Nebogatov

Committed to bzr rev. 10503.

#11 - 04/02/2014 05:50 PM - Eric Faulhaber

- % Done changed from 0 to 100

- Status changed from New to Closed

#12 - 11/16/2016 12:07 PM - Greg Shah

- Target version changed from Milestone 11 to Cleanup and Stablization for Server Features

Files

05/12/2024 3/4



vmn_upd20140331a.zip 29.6 KB 03/31/2014 Vadim Nebogatov
